/**
 * Limits the number of concurrent requests.
 * Requests can be delayed or rejected.
 * Sample config:
 * [
 *  { count: 20 },
 *  { count: 10, delay:  100 },
 *  { count:  5, delay:   10 }
 * ]
 *  1 -  4 : no delay
 *  5 -  9 : 10ms delay
 * 10 - 19 : 100ms delay
 * 20      : reject
 * default is to reject when more than 10 requests are on the way
 */
export class LimitingInterceptor extends Interceptor {
    limits: any;
    ongoingResponses: Set<any>;
    ongoingRequests: number;
    receive(endpoint: any, next: any, ...args: any[]): Promise<any>;
    _processRequest(next: any, ...args: any[]): any;
}
import { Interceptor } from "./interceptor.mjs";
